using ComputerVisionMetrics
using Test

@testset "_hausdorff_metric" begin
    seg_pred = [
        0 0 0 0 0
        0 1 1 1 0
        0 1 1 1 0
        0 1 1 1 0
        0 1 1 1 0
        0 0 0 0 0
    ]
    seg_gt = copy(seg_pred)
    edges_pred, edges_gt = get_mask_edges(seg_pred, seg_gt)
    @test ComputerVisionMetrics._hausdorff_metric(edges_pred, edges_gt) == 0
    @test ComputerVisionMetrics._hausdorff_metric(edges_pred, edges_gt, per=40) == 0
    
    seg_pred = cat(seg_pred, seg_pred, dims=3)
    seg_gt = copy(seg_pred)
    edges_pred, edges_gt = get_mask_edges(seg_pred, seg_gt)
    @test ComputerVisionMetrics._hausdorff_metric(edges_pred, edges_gt) == 0
    @test ComputerVisionMetrics._hausdorff_metric(edges_pred, edges_gt, per=40) == 0
end

@testset "hausdorff_metric" begin
    seg_pred = [
        0 0 0 0 0
        0 1 1 1 0
        0 1 1 1 0
        0 1 1 1 0
        0 1 1 1 0
        0 0 0 0 0
    ]
    seg_gt = copy(seg_pred)
    @test hausdorff_metric(seg_pred, seg_gt) == 0
    @test hausdorff_metric(seg_pred, seg_gt, per=40) == 0

    seg_pred = cat(seg_pred, seg_pred, dims=3)
    seg_gt = copy(seg_pred)
    @test hausdorff_metric(seg_pred, seg_gt) == 0
    @test hausdorff_metric(seg_pred, seg_gt, per=40) == 0
end
